#include <boost/utility.hpp>

class Test:public boost::noncopyable
{
protected:
	int a;
public:
	Test(){a=2;}
};


int main()
{
	Test t;
	Test t2 = t;
	return 0;
}

/*!F
	Voici un exemple simple qui ne compile pas !
	En effet, j'ai cr une classe Test, et je la fais hriter de boost::noncopyable

	Et du coup, ma ligne Test t2 = t, qui tente une recopie, est interdite !

	Notez qu'on peut faire a sans boost : Si on veut qu'une classe ne soit pas recopiable, il suffit de dclarer
	le constructeur de recopie (mme vide) et la surcharge de l'oprateur = en private.

	Commentez la ligne 
	Test t2 = t; 
	pour que le programme compile.

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Empcher une classe d'tre recopiable
titreE: Non copyable class.
meta: C++;boost
metaE: C++;boost
desc : Empcher une classe d'tre recopiable
descE: Non copyable class.
cle  : boost::noncopyable
parag: 3.5.1. Utility.
*/
